package b4a.example;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = true;
	public static final boolean includeTitle = false;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
//        try {
//            if (processBA.subExists("activity_actionbarhomeclick")) {
//                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
//                    getClass().getMethod("getActionBar").invoke(this), true);
//                BA.Log("adding event");
//            }
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
		return true;
	}   
// @Override
// public boolean onOptionsItemSelected(android.view.MenuItem item) {
//    if (item.getItemId() == 16908332) {
//        processBA.raiseEvent(null, "activity_actionbarhomeclick");
//        return true;
//    }
//    else
//        return super.onOptionsItemSelected(item); 
//}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static b4a.example.clsmap _gamemap = null;
public static anywheresoftware.b4a.libgdx.graphics.lgTextureAtlas _mainatlas = null;
public anywheresoftware.b4a.libgdx.LibGDX _folgdx = null;
public anywheresoftware.b4a.objects.ConcreteViewWrapper _fosurface = null;
public anywheresoftware.b4a.libgdx.graphics.lgGL _fogl = null;
public anywheresoftware.b4a.libgdx.utils.lgAssetManager _foam = null;
public anywheresoftware.b4a.libgdx.scene2d.lgStage[] _fostage = null;
public anywheresoftware.b4a.libgdx.scene2d.lgTable[] _fotable = null;
public anywheresoftware.b4a.libgdx.lgScreenManager _folgdx_scrmgr = null;
public anywheresoftware.b4a.libgdx.lgScreenManager.lgScreen[] _folgdx_screen = null;
public anywheresoftware.b4a.libgdx.graphics.lgBitmapFont _focomicfont = null;
public anywheresoftware.b4a.libgdx.scene2d.lgLabel _lblscore = null;
public anywheresoftware.b4a.libgdx.scene2d.lgLabel _lblhighscore = null;
public com.badlogic.gdx.scenes.scene2d.Group _grpmap = null;
public anywheresoftware.b4a.libgdx.scene2d.lgTable _tbllives = null;
public anywheresoftware.b4a.libgdx.graphics.lgTextureAtlasRegion _liferegion = null;
public static long _fltouchdown = 0L;
public static boolean _fboktorender = false;
public anywheresoftware.b4a.objects.PanelWrapper _panloading = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblloadinghead = null;
public anywheresoftware.b4a.objects.ProgressBarWrapper _pgbloading = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
com.badlogic.gdx.backends.android.AndroidApplicationConfiguration _config = null;
anywheresoftware.b4a.objects.drawable.ColorDrawable _pocd = null;
 //BA.debugLineNum = 52;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 55;BA.debugLine="Dim Config As lgConfiguration";
_config = new com.badlogic.gdx.backends.android.AndroidApplicationConfiguration();
 //BA.debugLineNum = 56;BA.debugLine="Config.useAccelerometer = False";
_config.useAccelerometer = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 57;BA.debugLine="Config.useCompass = False";
_config.useCompass = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 58;BA.debugLine="Config.useWakelock = True";
_config.useWakelock = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 59;BA.debugLine="Config.maxSimultaneousSounds = 6";
_config.maxSimultaneousSounds = (int) (6);
 //BA.debugLineNum = 61;BA.debugLine="foSurface = foLGdx.InitializeView2(Config, \"LG\")";
mostCurrent._fosurface = mostCurrent._folgdx.InitializeView2(mostCurrent.activityBA,_config,"LG");
 //BA.debugLineNum = 62;BA.debugLine="Activity.AddView(foSurface, 0,  0, 100%x, 100%y)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._fosurface.getObject()),(int) (0),(int) (0),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (100),mostCurrent.activityBA));
 //BA.debugLineNum = 65;BA.debugLine="panLoading.Initialize(\"\")";
mostCurrent._panloading.Initialize(mostCurrent.activityBA,"");
 //BA.debugLineNum = 66;BA.debugLine="Dim poCD As ColorDrawable";
_pocd = new anywheresoftware.b4a.objects.drawable.ColorDrawable();
 //BA.debugLineNum = 67;BA.debugLine="poCD.Initialize(Colors.Black, 0)";
_pocd.Initialize(anywheresoftware.b4a.keywords.Common.Colors.Black,(int) (0));
 //BA.debugLineNum = 68;BA.debugLine="Activity.AddView(panLoading, 0, 0, 100%x, 100%y)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._panloading.getObject()),(int) (0),(int) (0),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (100),mostCurrent.activityBA));
 //BA.debugLineNum = 69;BA.debugLine="panLoading.LoadLayout(\"layLoading\")";
mostCurrent._panloading.LoadLayout("layLoading",mostCurrent.activityBA);
 //BA.debugLineNum = 70;BA.debugLine="panLoading.Color = Colors.Black";
mostCurrent._panloading.setColor(anywheresoftware.b4a.keywords.Common.Colors.Black);
 //BA.debugLineNum = 71;BA.debugLine="panLoading.Background = poCD";
mostCurrent._panloading.setBackground((android.graphics.drawable.Drawable)(_pocd.getObject()));
 //BA.debugLineNum = 72;BA.debugLine="panLoading.BringToFront";
mostCurrent._panloading.BringToFront();
 //BA.debugLineNum = 73;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 80;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 82;BA.debugLine="If foLGdx.IsInitialized Then foLGdx.Pause";
if (mostCurrent._folgdx.IsInitialized()) { 
mostCurrent._folgdx.Pause();};
 //BA.debugLineNum = 83;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 75;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 77;BA.debugLine="If foLGdx.IsInitialized Then foLGdx.Resume";
if (mostCurrent._folgdx.IsInitialized()) { 
mostCurrent._folgdx.Resume();};
 //BA.debugLineNum = 78;BA.debugLine="End Sub";
return "";
}
public static String  _am_error(String _filename,Object _class,String _message) throws Exception{
 //BA.debugLineNum = 141;BA.debugLine="Sub AM_Error(FileName As String, Class As Object, Message As String)";
 //BA.debugLineNum = 142;BA.debugLine="LogColor(\"- libGDX AssetManager ERROR !!! ---\", Colors.Red)";
anywheresoftware.b4a.keywords.Common.LogColor("- libGDX AssetManager ERROR !!! ---",anywheresoftware.b4a.keywords.Common.Colors.Red);
 //BA.debugLineNum = 143;BA.debugLine="LogColor(\"     FileName = \" & FileName, Colors.Red)";
anywheresoftware.b4a.keywords.Common.LogColor("     FileName = "+_filename,anywheresoftware.b4a.keywords.Common.Colors.Red);
 //BA.debugLineNum = 144;BA.debugLine="LogColor(\"     Class = \" & Class, Colors.Red)";
anywheresoftware.b4a.keywords.Common.LogColor("     Class = "+BA.ObjectToString(_class),anywheresoftware.b4a.keywords.Common.Colors.Red);
 //BA.debugLineNum = 145;BA.debugLine="LogColor(\"     Message = \" & Message, Colors.Red)";
anywheresoftware.b4a.keywords.Common.LogColor("     Message = "+_message,anywheresoftware.b4a.keywords.Common.Colors.Red);
 //BA.debugLineNum = 146;BA.debugLine="LogColor(\"- libGDX AssetManager ERROR !!! ---\", Colors.Red)";
anywheresoftware.b4a.keywords.Common.LogColor("- libGDX AssetManager ERROR !!! ---",anywheresoftware.b4a.keywords.Common.Colors.Red);
 //BA.debugLineNum = 147;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 20;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 21;BA.debugLine="Dim foLGdx As LibGDX";
mostCurrent._folgdx = new anywheresoftware.b4a.libgdx.LibGDX();
 //BA.debugLineNum = 22;BA.debugLine="Dim foSurface As View";
mostCurrent._fosurface = new anywheresoftware.b4a.objects.ConcreteViewWrapper();
 //BA.debugLineNum = 23;BA.debugLine="Dim foGL As lgGL";
mostCurrent._fogl = new anywheresoftware.b4a.libgdx.graphics.lgGL();
 //BA.debugLineNum = 24;BA.debugLine="Dim foAM As lgAssetManager";
mostCurrent._foam = new anywheresoftware.b4a.libgdx.utils.lgAssetManager();
 //BA.debugLineNum = 25;BA.debugLine="Dim foStage(2) As lgScn2DStage";
mostCurrent._fostage = new anywheresoftware.b4a.libgdx.scene2d.lgStage[(int) (2)];
{
int d0 = mostCurrent._fostage.length;
for (int i0 = 0;i0 < d0;i0++) {
mostCurrent._fostage[i0] = new anywheresoftware.b4a.libgdx.scene2d.lgStage();
}
}
;
 //BA.debugLineNum = 26;BA.debugLine="Dim foTable(2) As lgScn2DTable";
mostCurrent._fotable = new anywheresoftware.b4a.libgdx.scene2d.lgTable[(int) (2)];
{
int d0 = mostCurrent._fotable.length;
for (int i0 = 0;i0 < d0;i0++) {
mostCurrent._fotable[i0] = new anywheresoftware.b4a.libgdx.scene2d.lgTable();
}
}
;
 //BA.debugLineNum = 28;BA.debugLine="Dim foLGdx_ScrMgr As lgScreenManager";
mostCurrent._folgdx_scrmgr = new anywheresoftware.b4a.libgdx.lgScreenManager();
 //BA.debugLineNum = 29;BA.debugLine="Dim foLGdx_Screen(2) As lgScreen";
mostCurrent._folgdx_screen = new anywheresoftware.b4a.libgdx.lgScreenManager.lgScreen[(int) (2)];
{
int d0 = mostCurrent._folgdx_screen.length;
for (int i0 = 0;i0 < d0;i0++) {
mostCurrent._folgdx_screen[i0] = new anywheresoftware.b4a.libgdx.lgScreenManager.lgScreen();
}
}
;
 //BA.debugLineNum = 32;BA.debugLine="Dim foComicFont As lgBitmapFont";
mostCurrent._focomicfont = new anywheresoftware.b4a.libgdx.graphics.lgBitmapFont();
 //BA.debugLineNum = 36;BA.debugLine="Dim lblScore As lgScn2DLabel";
mostCurrent._lblscore = new anywheresoftware.b4a.libgdx.scene2d.lgLabel();
 //BA.debugLineNum = 37;BA.debugLine="Dim lblHighScore As lgScn2DLabel";
mostCurrent._lblhighscore = new anywheresoftware.b4a.libgdx.scene2d.lgLabel();
 //BA.debugLineNum = 38;BA.debugLine="Dim grpMap As lgScn2DGroup";
mostCurrent._grpmap = new com.badlogic.gdx.scenes.scene2d.Group();
 //BA.debugLineNum = 39;BA.debugLine="Dim tblLives As lgScn2DTable";
mostCurrent._tbllives = new anywheresoftware.b4a.libgdx.scene2d.lgTable();
 //BA.debugLineNum = 40;BA.debugLine="Dim LifeRegion As lgTextureAtlasRegion";
mostCurrent._liferegion = new anywheresoftware.b4a.libgdx.graphics.lgTextureAtlasRegion();
 //BA.debugLineNum = 43;BA.debugLine="Dim flTouchDown As Long";
_fltouchdown = 0L;
 //BA.debugLineNum = 44;BA.debugLine="Dim fbOkToRender As Boolean";
_fboktorender = false;
 //BA.debugLineNum = 47;BA.debugLine="Private panLoading As Panel";
mostCurrent._panloading = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 48;BA.debugLine="Private lblLoadingHead As Label";
mostCurrent._lblloadinghead = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 49;BA.debugLine="Private pgbLoading As ProgressBar";
mostCurrent._pgbloading = new anywheresoftware.b4a.objects.ProgressBarWrapper();
 //BA.debugLineNum = 50;BA.debugLine="End Sub";
return "";
}
public static String  _grpmap_draw(anywheresoftware.b4a.libgdx.graphics.lgSpriteBatch _spritebatch,float _parentalpha) throws Exception{
 //BA.debugLineNum = 318;BA.debugLine="Sub grpMap_Draw(SpriteBatch As lgSpriteBatch, ParentAlpha As Float)";
 //BA.debugLineNum = 320;BA.debugLine="SpriteBatch.DisableBlending";
_spritebatch.DisableBlending();
 //BA.debugLineNum = 321;BA.debugLine="SpriteBatch.SetColorRGBA(1, 1, 1, 1)";
_spritebatch.SetColorRGBA((float) (1),(float) (1),(float) (1),(float) (1));
 //BA.debugLineNum = 322;BA.debugLine="GameMap.DrawAll(foStage(1).Camera)";
_gamemap._drawall(mostCurrent._fostage[(int) (1)].getCamera());
 //BA.debugLineNum = 323;BA.debugLine="SpriteBatch.EnableBlending";
_spritebatch.EnableBlending();
 //BA.debugLineNum = 324;BA.debugLine="End Sub";
return "";
}
public static String  _hide_loading(Object _dummy) throws Exception{
 //BA.debugLineNum = 160;BA.debugLine="Private Sub Hide_Loading(Dummy As Object)";
 //BA.debugLineNum = 161;BA.debugLine="If panLoading.Visible = True Then";
if (mostCurrent._panloading.getVisible()==anywheresoftware.b4a.keywords.Common.True) { 
 //BA.debugLineNum = 162;BA.debugLine="pgbLoading.Progress = 100";
mostCurrent._pgbloading.setProgress((int) (100));
 //BA.debugLineNum = 163;BA.debugLine="DoEvents";
anywheresoftware.b4a.keywords.Common.DoEvents();
 //BA.debugLineNum = 164;BA.debugLine="panLoading.Visible = False";
mostCurrent._panloading.setVisible(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 165;BA.debugLine="DoEvents";
anywheresoftware.b4a.keywords.Common.DoEvents();
 };
 //BA.debugLineNum = 167;BA.debugLine="End Sub";
return "";
}
public static String  _lg_create() throws Exception{
 //BA.debugLineNum = 85;BA.debugLine="Sub LG_Create";
 //BA.debugLineNum = 87;BA.debugLine="foAM.Initialize(\"AM\")";
mostCurrent._foam.Initialize(processBA,"AM");
 //BA.debugLineNum = 90;BA.debugLine="foAM.Load(\"audio/ding.ogg\", foAM.TYPE_Sound)";
mostCurrent._foam.Load("audio/ding.ogg",mostCurrent._foam.TYPE_Sound);
 //BA.debugLineNum = 91;BA.debugLine="foAM.Load(\"parts/explode_02.p\", foAM.TYPE_ParticleEffect)";
mostCurrent._foam.Load("parts/explode_02.p",mostCurrent._foam.TYPE_ParticleEffect);
 //BA.debugLineNum = 92;BA.debugLine="foAM.Load(\"atlas/atlas.pack\", foAM.TYPE_TextureAtlas)";
mostCurrent._foam.Load("atlas/atlas.pack",mostCurrent._foam.TYPE_TextureAtlas);
 //BA.debugLineNum = 93;BA.debugLine="foAM.Load(\"fonts/comic2.fnt\", foAM.TYPE_BitmapFont)";
mostCurrent._foam.Load("fonts/comic2.fnt",mostCurrent._foam.TYPE_BitmapFont);
 //BA.debugLineNum = 96;BA.debugLine="End Sub";
return "";
}
public static String  _lg_dispose() throws Exception{
 //BA.debugLineNum = 134;BA.debugLine="Sub LG_Dispose";
 //BA.debugLineNum = 135;BA.debugLine="foComicFont.dispose";
mostCurrent._focomicfont.dispose();
 //BA.debugLineNum = 136;BA.debugLine="MainAtlas.dispose";
_mainatlas.dispose();
 //BA.debugLineNum = 137;BA.debugLine="foAM.dispose";
mostCurrent._foam.dispose();
 //BA.debugLineNum = 138;BA.debugLine="End Sub";
return "";
}
public static String  _lg_pause() throws Exception{
 //BA.debugLineNum = 126;BA.debugLine="Sub LG_Pause";
 //BA.debugLineNum = 128;BA.debugLine="End Sub";
return "";
}
public static String  _lg_render() throws Exception{
 //BA.debugLineNum = 102;BA.debugLine="Sub LG_Render";
 //BA.debugLineNum = 104;BA.debugLine="If foAM.Update Then";
if (mostCurrent._foam.Update()) { 
 //BA.debugLineNum = 105;BA.debugLine="foLGdx.CallSubUI(\"Update_Loading\", foAM.Progress)";
mostCurrent._folgdx.CallSubUI(mostCurrent.activityBA,"Update_Loading",(Object)(mostCurrent._foam.getProgress()));
 //BA.debugLineNum = 106;BA.debugLine="Return";
if (true) return "";
 }else {
 //BA.debugLineNum = 109;BA.debugLine="foComicFont = foAM.Get(\"fonts/comic2.fnt\")";
mostCurrent._focomicfont = (anywheresoftware.b4a.libgdx.graphics.lgBitmapFont)(mostCurrent._foam.Get("fonts/comic2.fnt"));
 //BA.debugLineNum = 110;BA.debugLine="foComicFont.SetTextureFilter(foComicFont.FILTER_Linear, foComicFont.FILTER_Linear)";
mostCurrent._focomicfont.SetTextureFilter(mostCurrent._focomicfont.FILTER_Linear,mostCurrent._focomicfont.FILTER_Linear);
 //BA.debugLineNum = 111;BA.debugLine="foComicFont.Scale(Density)";
mostCurrent._focomicfont.Scale(anywheresoftware.b4a.keywords.Common.Density);
 //BA.debugLineNum = 113;BA.debugLine="MainAtlas = foAM.Get(\"atlas/atlas.pack\")";
_mainatlas = (anywheresoftware.b4a.libgdx.graphics.lgTextureAtlas)(mostCurrent._foam.Get("atlas/atlas.pack"));
 //BA.debugLineNum = 116;BA.debugLine="fbOkToRender = False";
_fboktorender = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 117;BA.debugLine="foLGdx_ScrMgr.Initialize(foLGdx)";
mostCurrent._folgdx_scrmgr.Initialize(mostCurrent._folgdx);
 //BA.debugLineNum = 118;BA.debugLine="foLGdx_Screen(0) = foLGdx_ScrMgr.AddScreen(\"LGS0\")";
mostCurrent._folgdx_screen[(int) (0)] = mostCurrent._folgdx_scrmgr.AddScreen(processBA,"LGS0");
 //BA.debugLineNum = 119;BA.debugLine="foLGdx_Screen(1) = foLGdx_ScrMgr.AddScreen(\"LGS1\")";
mostCurrent._folgdx_screen[(int) (1)] = mostCurrent._folgdx_scrmgr.AddScreen(processBA,"LGS1");
 //BA.debugLineNum = 120;BA.debugLine="foLGdx_ScrMgr.CurrentScreen = foLGdx_Screen(0)";
mostCurrent._folgdx_scrmgr.setCurrentScreen(mostCurrent._folgdx_screen[(int) (0)]);
 //BA.debugLineNum = 122;BA.debugLine="foLGdx.CallSubUI(\"Hide_Loading\", Null)";
mostCurrent._folgdx.CallSubUI(mostCurrent.activityBA,"Hide_Loading",anywheresoftware.b4a.keywords.Common.Null);
 };
 //BA.debugLineNum = 124;BA.debugLine="End Sub";
return "";
}
public static String  _lg_resize(int _width,int _height) throws Exception{
 //BA.debugLineNum = 98;BA.debugLine="Sub LG_Resize(Width As Int, Height As Int)";
 //BA.debugLineNum = 100;BA.debugLine="End Sub";
return "";
}
public static String  _lg_resume() throws Exception{
 //BA.debugLineNum = 130;BA.debugLine="Sub LG_Resume";
 //BA.debugLineNum = 132;BA.debugLine="End Sub";
return "";
}
public static String  _lgs0_hide() throws Exception{
 //BA.debugLineNum = 225;BA.debugLine="Sub LGS0_Hide";
 //BA.debugLineNum = 226;BA.debugLine="foStage(0).dispose";
mostCurrent._fostage[(int) (0)].dispose();
 //BA.debugLineNum = 227;BA.debugLine="End Sub";
return "";
}
public static String  _lgs0_pause() throws Exception{
 //BA.debugLineNum = 217;BA.debugLine="Sub LGS0_Pause";
 //BA.debugLineNum = 219;BA.debugLine="End Sub";
return "";
}
public static String  _lgs0_render(float _delta) throws Exception{
 //BA.debugLineNum = 201;BA.debugLine="Sub LGS0_Render(Delta As Float)";
 //BA.debugLineNum = 203;BA.debugLine="foGL.glClearColor(1, 0 , 0, 1)";
mostCurrent._fogl.glClearColor((float) (1),(float) (0),(float) (0),(float) (1));
 //BA.debugLineNum = 204;BA.debugLine="foGL.glClear(foGL.GL10_COLOR_BUFFER_BIT)";
mostCurrent._fogl.glClear(mostCurrent._fogl.GL10_COLOR_BUFFER_BIT);
 //BA.debugLineNum = 206;BA.debugLine="If fbOkToRender = False Then";
if (_fboktorender==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 207;BA.debugLine="Return";
if (true) return "";
 };
 //BA.debugLineNum = 211;BA.debugLine="foStage(0).Act2(Delta)";
mostCurrent._fostage[(int) (0)].Act2(_delta);
 //BA.debugLineNum = 214;BA.debugLine="foStage(0).Draw";
mostCurrent._fostage[(int) (0)].Draw();
 //BA.debugLineNum = 215;BA.debugLine="End Sub";
return "";
}
public static String  _lgs0_resize(int _width,int _height) throws Exception{
 //BA.debugLineNum = 196;BA.debugLine="Sub LGS0_Resize(Width As Int, Height As Int)";
 //BA.debugLineNum = 198;BA.debugLine="foStage(0).SetViewport(Width, Height, True)";
mostCurrent._fostage[(int) (0)].SetViewport((float) (_width),(float) (_height),anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 199;BA.debugLine="End Sub";
return "";
}
public static String  _lgs0_resume() throws Exception{
 //BA.debugLineNum = 221;BA.debugLine="Sub LGS0_Resume";
 //BA.debugLineNum = 223;BA.debugLine="End Sub";
return "";
}
public static String  _lgs0_show() throws Exception{
com.badlogic.gdx.scenes.scene2d.InputListener _il = null;
 //BA.debugLineNum = 174;BA.debugLine="Sub LGS0_Show";
 //BA.debugLineNum = 175;BA.debugLine="fbOkToRender = False";
_fboktorender = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 176;BA.debugLine="If foStage(0).IsInitialized = False Then";
if (mostCurrent._fostage[(int) (0)].IsInitialized()==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 178;BA.debugLine="foStage(0).Initialize(\"ST_0\")";
mostCurrent._fostage[(int) (0)].Initialize(processBA,"ST_0");
 //BA.debugLineNum = 181;BA.debugLine="Dim IL As lgScn2DInputListener";
_il = new com.badlogic.gdx.scenes.scene2d.InputListener();
 //BA.debugLineNum = 182;BA.debugLine="IL.Initialize(\"ST_0\")";
_il.Initialize(processBA,"ST_0");
 //BA.debugLineNum = 183;BA.debugLine="foStage(0).AddCaptureListener(IL)";
mostCurrent._fostage[(int) (0)].AddCaptureListener((com.badlogic.gdx.scenes.scene2d.EventListener)(_il));
 //BA.debugLineNum = 186;BA.debugLine="foTable(0).Initialize(\"Table0\")";
mostCurrent._fotable[(int) (0)].Initialize(processBA,"Table0");
 //BA.debugLineNum = 187;BA.debugLine="foTable(0) = foTable(0)";
mostCurrent._fotable[(int) (0)] = mostCurrent._fotable[(int) (0)];
 //BA.debugLineNum = 188;BA.debugLine="foTable(0).FillParent = True";
mostCurrent._fotable[(int) (0)].setFillParent(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 189;BA.debugLine="foStage(0).AddActor(foTable(0))";
mostCurrent._fostage[(int) (0)].AddActor((com.badlogic.gdx.scenes.scene2d.Actor)(mostCurrent._fotable[(int) (0)]));
 //BA.debugLineNum = 191;BA.debugLine="foLGdx.CallSubUI(\"ST0_Toast_Show\", Null)";
mostCurrent._folgdx.CallSubUI(mostCurrent.activityBA,"ST0_Toast_Show",anywheresoftware.b4a.keywords.Common.Null);
 };
 //BA.debugLineNum = 193;BA.debugLine="fbOkToRender = True";
_fboktorender = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 194;BA.debugLine="End Sub";
return "";
}
public static String  _lgs1_hide() throws Exception{
 //BA.debugLineNum = 334;BA.debugLine="Sub LGS1_Hide";
 //BA.debugLineNum = 335;BA.debugLine="foStage(1).dispose";
mostCurrent._fostage[(int) (1)].dispose();
 //BA.debugLineNum = 336;BA.debugLine="End Sub";
return "";
}
public static String  _lgs1_pause() throws Exception{
 //BA.debugLineNum = 326;BA.debugLine="Sub LGS1_Pause";
 //BA.debugLineNum = 328;BA.debugLine="End Sub";
return "";
}
public static String  _lgs1_render(float _delta) throws Exception{
 //BA.debugLineNum = 306;BA.debugLine="Sub LGS1_Render(Delta As Float)";
 //BA.debugLineNum = 308;BA.debugLine="foGL.glClearColor(0, 0 , 1, 1)";
mostCurrent._fogl.glClearColor((float) (0),(float) (0),(float) (1),(float) (1));
 //BA.debugLineNum = 309;BA.debugLine="foGL.glClear(foGL.GL10_COLOR_BUFFER_BIT)";
mostCurrent._fogl.glClear(mostCurrent._fogl.GL10_COLOR_BUFFER_BIT);
 //BA.debugLineNum = 312;BA.debugLine="foStage(1).Act2(Delta)";
mostCurrent._fostage[(int) (1)].Act2(_delta);
 //BA.debugLineNum = 315;BA.debugLine="foStage(1).Draw";
mostCurrent._fostage[(int) (1)].Draw();
 //BA.debugLineNum = 316;BA.debugLine="End Sub";
return "";
}
public static String  _lgs1_resize(int _width,int _height) throws Exception{
 //BA.debugLineNum = 301;BA.debugLine="Sub LGS1_Resize(Width As Int, Height As Int)";
 //BA.debugLineNum = 303;BA.debugLine="foStage(1).SetViewport(Width, Height, True)";
mostCurrent._fostage[(int) (1)].SetViewport((float) (_width),(float) (_height),anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 304;BA.debugLine="End Sub";
return "";
}
public static String  _lgs1_resume() throws Exception{
 //BA.debugLineNum = 330;BA.debugLine="Sub LGS1_Resume";
 //BA.debugLineNum = 332;BA.debugLine="End Sub";
return "";
}
public static String  _lgs1_show() throws Exception{
com.badlogic.gdx.scenes.scene2d.InputListener _il = null;
 //BA.debugLineNum = 275;BA.debugLine="Sub LGS1_Show";
 //BA.debugLineNum = 277;BA.debugLine="fbOkToRender = False";
_fboktorender = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 279;BA.debugLine="If foStage(1).IsInitialized = False Then";
if (mostCurrent._fostage[(int) (1)].IsInitialized()==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 280;BA.debugLine="foStage(1).Initialize(\"ST_1\")";
mostCurrent._fostage[(int) (1)].Initialize(processBA,"ST_1");
 //BA.debugLineNum = 283;BA.debugLine="Dim IL As lgScn2DInputListener";
_il = new com.badlogic.gdx.scenes.scene2d.InputListener();
 //BA.debugLineNum = 284;BA.debugLine="IL.Initialize(\"ST_1\")";
_il.Initialize(processBA,"ST_1");
 //BA.debugLineNum = 285;BA.debugLine="foStage(1).AddCaptureListener(IL)";
mostCurrent._fostage[(int) (1)].AddCaptureListener((com.badlogic.gdx.scenes.scene2d.EventListener)(_il));
 //BA.debugLineNum = 288;BA.debugLine="foTable(1).Initialize(\"Table1\")";
mostCurrent._fotable[(int) (1)].Initialize(processBA,"Table1");
 //BA.debugLineNum = 289;BA.debugLine="foTable(1).FillParent = True";
mostCurrent._fotable[(int) (1)].setFillParent(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 290;BA.debugLine="foStage(1).AddActor(foTable(1))";
mostCurrent._fostage[(int) (1)].AddActor((com.badlogic.gdx.scenes.scene2d.Actor)(mostCurrent._fotable[(int) (1)]));
 //BA.debugLineNum = 292;BA.debugLine="SetupScreen1";
_setupscreen1();
 //BA.debugLineNum = 293;BA.debugLine="foLGdx.CallSubUI(\"ST1_Toast_Show\", Null)";
mostCurrent._folgdx.CallSubUI(mostCurrent.activityBA,"ST1_Toast_Show",anywheresoftware.b4a.keywords.Common.Null);
 };
 //BA.debugLineNum = 298;BA.debugLine="fbOkToRender = True";
_fboktorender = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 299;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 16;BA.debugLine="Public GameMap As clsMap";
_gamemap = new b4a.example.clsmap();
 //BA.debugLineNum = 17;BA.debugLine="Public MainAtlas As lgTextureAtlas";
_mainatlas = new anywheresoftware.b4a.libgdx.graphics.lgTextureAtlas();
 //BA.debugLineNum = 18;BA.debugLine="End Sub";
return "";
}
public static String  _setupscreen1() throws Exception{
float _pftextheight = 0f;
float _pffontsize = 0f;
anywheresoftware.b4a.libgdx.scene2d.lgLabel.lgLabelStyle _lblstyle = null;
com.badlogic.gdx.scenes.scene2d.ui.Cell _maincell = null;
com.badlogic.gdx.scenes.scene2d.ui.Cell _livescell = null;
int _i = 0;
anywheresoftware.b4a.libgdx.scene2d.lgImage _image = null;
 //BA.debugLineNum = 383;BA.debugLine="Sub SetupScreen1";
 //BA.debugLineNum = 384;BA.debugLine="Dim pfTextheight As Float";
_pftextheight = 0f;
 //BA.debugLineNum = 385;BA.debugLine="Dim pfFontSize As Float = 0.90";
_pffontsize = (float) (0.90);
 //BA.debugLineNum = 388;BA.debugLine="Dim lblStyle As lgScn2DLabelStyle";
_lblstyle = new anywheresoftware.b4a.libgdx.scene2d.lgLabel.lgLabelStyle();
 //BA.debugLineNum = 389;BA.debugLine="lblStyle.Initialize(foComicFont, foComicFont.Color.WHITE)";
_lblstyle.Initialize(mostCurrent._focomicfont,mostCurrent._focomicfont.getColor().WHITE);
 //BA.debugLineNum = 390;BA.debugLine="lblScore.Initialize(\"Score\" & CRLF & \"000000\", lblStyle, \"\")";
mostCurrent._lblscore.Initialize(processBA,(java.lang.CharSequence)("Score"+anywheresoftware.b4a.keywords.Common.CRLF+"000000"),_lblstyle,"");
 //BA.debugLineNum = 391;BA.debugLine="lblScore.SetFontScale2(pfFontSize)";
mostCurrent._lblscore.SetFontScale2(_pffontsize);
 //BA.debugLineNum = 392;BA.debugLine="foTable(1).AddActor(lblScore).AlignLeft";
mostCurrent._fotable[(int) (1)].AddActor((com.badlogic.gdx.scenes.scene2d.Actor)(mostCurrent._lblscore)).AlignLeft();
 //BA.debugLineNum = 395;BA.debugLine="lblHighScore.Initialize(\"High\" & CRLF & \"000000\", lblStyle, \"\")";
mostCurrent._lblhighscore.Initialize(processBA,(java.lang.CharSequence)("High"+anywheresoftware.b4a.keywords.Common.CRLF+"000000"),_lblstyle,"");
 //BA.debugLineNum = 396;BA.debugLine="lblHighScore.SetFontScale2(pfFontSize)";
mostCurrent._lblhighscore.SetFontScale2(_pffontsize);
 //BA.debugLineNum = 397;BA.debugLine="foTable(1).AddActor(lblHighScore).AlignRight.ExpandX = 1";
mostCurrent._fotable[(int) (1)].AddActor((com.badlogic.gdx.scenes.scene2d.Actor)(mostCurrent._lblhighscore)).AlignRight().setExpandX((int) (1));
 //BA.debugLineNum = 399;BA.debugLine="pfTextheight = lblScore.TextBounds.Height";
_pftextheight = mostCurrent._lblscore.getTextBounds().Height;
 //BA.debugLineNum = 401;BA.debugLine="foTable(1).NewRow";
mostCurrent._fotable[(int) (1)].NewRow();
 //BA.debugLineNum = 404;BA.debugLine="GameMap.Initialize(1, foLGdx.Graphics.Width, foLGdx.Graphics.Height, (pfTextheight * 2), tblLives.Height, foStage(1))";
_gamemap._initialize(processBA,(int) (1),mostCurrent._folgdx.Graphics().getWidth(),mostCurrent._folgdx.Graphics().getHeight(),(float) ((_pftextheight*2)),mostCurrent._tbllives.getHeight(),mostCurrent._fostage[(int) (1)]);
 //BA.debugLineNum = 407;BA.debugLine="grpMap.Initialize(\"grpMap\")";
mostCurrent._grpmap.Initialize(processBA,"grpMap");
 //BA.debugLineNum = 408;BA.debugLine="grpMap.Height = GameMap.TileSize * GameMap.MapHeight";
mostCurrent._grpmap.setHeight((float) (_gamemap._tilesize*_gamemap._mapheight));
 //BA.debugLineNum = 409;BA.debugLine="grpMap.Width = GameMap.TileSize * GameMap.MapWidth";
mostCurrent._grpmap.setWidth((float) (_gamemap._tilesize*_gamemap._mapwidth));
 //BA.debugLineNum = 410;BA.debugLine="Dim MainCell As lgScn2DTableCell = foTable(1).AddCell";
_maincell = mostCurrent._fotable[(int) (1)].AddCell();
 //BA.debugLineNum = 411;BA.debugLine="MainCell.Actor = grpMap";
_maincell.setActor((Object)(mostCurrent._grpmap));
 //BA.debugLineNum = 412;BA.debugLine="MainCell.Colspan = 2";
_maincell.setColspan((int) (2));
 //BA.debugLineNum = 413;BA.debugLine="MainCell.Expand";
_maincell.Expand();
 //BA.debugLineNum = 415;BA.debugLine="foTable(1).NewRow";
mostCurrent._fotable[(int) (1)].NewRow();
 //BA.debugLineNum = 418;BA.debugLine="tblLives.Initialize(\"\")";
mostCurrent._tbllives.Initialize(processBA,"");
 //BA.debugLineNum = 419;BA.debugLine="tblLives.AddCell.Height = pfTextheight";
mostCurrent._tbllives.AddCell().setHeight(_pftextheight);
 //BA.debugLineNum = 420;BA.debugLine="Dim LivesCell As lgScn2DTableCell = foTable(1).AddCell";
_livescell = mostCurrent._fotable[(int) (1)].AddCell();
 //BA.debugLineNum = 421;BA.debugLine="LivesCell.Actor = tblLives";
_livescell.setActor((Object)(mostCurrent._tbllives));
 //BA.debugLineNum = 422;BA.debugLine="LivesCell.Colspan = 2";
_livescell.setColspan((int) (2));
 //BA.debugLineNum = 423;BA.debugLine="LivesCell.AlignLeft";
_livescell.AlignLeft();
 //BA.debugLineNum = 426;BA.debugLine="LifeRegion = MainAtlas.FindRegion2(\"miner_right_no_pick\", 0)";
mostCurrent._liferegion = _mainatlas.FindRegion2("miner_right_no_pick",(int) (0));
 //BA.debugLineNum = 429;BA.debugLine="tblLives.AddCell.Height = pfTextheight";
mostCurrent._tbllives.AddCell().setHeight(_pftextheight);
 //BA.debugLineNum = 430;BA.debugLine="For i = 1 To 3";
{
final int step257 = 1;
final int limit257 = (int) (3);
for (_i = (int) (1); (step257 > 0 && _i <= limit257) || (step257 < 0 && _i >= limit257); _i = ((int)(0 + _i + step257))) {
 //BA.debugLineNum = 431;BA.debugLine="Dim Image As lgScn2DImage";
_image = new anywheresoftware.b4a.libgdx.scene2d.lgImage();
 //BA.debugLineNum = 432;BA.debugLine="Image.Initialize3(LifeRegion, \"\")";
_image.Initialize3(processBA,(anywheresoftware.b4a.libgdx.graphics.lgTextureRegion)(mostCurrent._liferegion),"");
 //BA.debugLineNum = 433;BA.debugLine="tblLives.AddActor(Image).SpaceRight = 5dip";
mostCurrent._tbllives.AddActor((com.badlogic.gdx.scenes.scene2d.Actor)(_image)).setSpaceRight((float) (anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (5))));
 }
};
 //BA.debugLineNum = 437;BA.debugLine="End Sub";
return "";
}
public static String  _show_loading(Object _dummy) throws Exception{
 //BA.debugLineNum = 149;BA.debugLine="Private Sub Show_Loading(dummy As Object)";
 //BA.debugLineNum = 150;BA.debugLine="pgbLoading.Progress = 0";
mostCurrent._pgbloading.setProgress((int) (0));
 //BA.debugLineNum = 151;BA.debugLine="panLoading.Visible = True";
mostCurrent._panloading.setVisible(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 152;BA.debugLine="DoEvents";
anywheresoftware.b4a.keywords.Common.DoEvents();
 //BA.debugLineNum = 153;BA.debugLine="End Sub";
return "";
}
public static String  _st_0_enter(com.badlogic.gdx.scenes.scene2d.InputEvent _event,float _x,float _y,int _pointer,com.badlogic.gdx.scenes.scene2d.Actor _fromactor) throws Exception{
 //BA.debugLineNum = 229;BA.debugLine="Sub ST_0_Enter(Event As lgScn2DInputEvent, X As Float, Y As Float, Pointer As Int, FromActor As lgScn2DActor)";
 //BA.debugLineNum = 231;BA.debugLine="End Sub";
return "";
}
public static String  _st_0_exit(com.badlogic.gdx.scenes.scene2d.InputEvent _event,float _x,float _y,int _pointer,com.badlogic.gdx.scenes.scene2d.Actor _toactor) throws Exception{
 //BA.debugLineNum = 233;BA.debugLine="Sub ST_0_Exit(Event As lgScn2DInputEvent, X As Float, Y As Float, Pointer As Int, ToActor As lgScn2DActor)";
 //BA.debugLineNum = 235;BA.debugLine="End Sub";
return "";
}
public static String  _st_0_keydown(com.badlogic.gdx.scenes.scene2d.InputEvent _event,int _keycode) throws Exception{
 //BA.debugLineNum = 237;BA.debugLine="Sub ST_0_KeyDown(Event As lgScn2DInputEvent, KeyCode As Int)";
 //BA.debugLineNum = 239;BA.debugLine="End Sub";
return "";
}
public static String  _st_0_keytyped(com.badlogic.gdx.scenes.scene2d.InputEvent _event,char _character) throws Exception{
 //BA.debugLineNum = 245;BA.debugLine="Sub ST_0_KeyTyped(Event As lgScn2DInputEvent, Character As Char)";
 //BA.debugLineNum = 247;BA.debugLine="End Sub";
return "";
}
public static String  _st_0_keyup(com.badlogic.gdx.scenes.scene2d.InputEvent _event,int _keycode) throws Exception{
 //BA.debugLineNum = 241;BA.debugLine="Sub ST_0_KeyUp(Event As lgScn2DInputEvent, KeyCode As Int)";
 //BA.debugLineNum = 243;BA.debugLine="End Sub";
return "";
}
public static String  _st_0_touchdown(com.badlogic.gdx.scenes.scene2d.InputEvent _event,float _x,float _y,int _pointer) throws Exception{
 //BA.debugLineNum = 249;BA.debugLine="Sub ST_0_TouchDown(Event As lgScn2DInputEvent, X As Float, Y As Float, Pointer As Int)";
 //BA.debugLineNum = 251;BA.debugLine="Event.Handle";
_event.handle();
 //BA.debugLineNum = 252;BA.debugLine="End Sub";
return "";
}
public static String  _st_0_touchdragged(com.badlogic.gdx.scenes.scene2d.InputEvent _event,float _x,float _y,int _pointer) throws Exception{
 //BA.debugLineNum = 254;BA.debugLine="Sub ST_0_TouchDragged(Event As lgScn2DInputEvent, X As Float, Y As Float, Pointer As Int)";
 //BA.debugLineNum = 256;BA.debugLine="End Sub";
return "";
}
public static String  _st_0_touchup(com.badlogic.gdx.scenes.scene2d.InputEvent _event,float _x,float _y,int _pointer) throws Exception{
 //BA.debugLineNum = 258;BA.debugLine="Sub ST_0_TouchUp(Event As lgScn2DInputEvent, X As Float, Y As Float, Pointer As Int)";
 //BA.debugLineNum = 259;BA.debugLine="foLGdx_ScrMgr.CurrentScreen = foLGdx_Screen(1)";
mostCurrent._folgdx_scrmgr.setCurrentScreen(mostCurrent._folgdx_screen[(int) (1)]);
 //BA.debugLineNum = 260;BA.debugLine="Event.handle";
_event.handle();
 //BA.debugLineNum = 261;BA.debugLine="End Sub";
return "";
}
public static String  _st_1_enter(com.badlogic.gdx.scenes.scene2d.InputEvent _event,float _x,float _y,int _pointer,com.badlogic.gdx.scenes.scene2d.Actor _fromactor) throws Exception{
 //BA.debugLineNum = 338;BA.debugLine="Sub ST_1_Enter(Event As lgScn2DInputEvent, X As Float, Y As Float, Pointer As Int, FromActor As lgScn2DActor)";
 //BA.debugLineNum = 340;BA.debugLine="End Sub";
return "";
}
public static String  _st_1_exit(com.badlogic.gdx.scenes.scene2d.InputEvent _event,float _x,float _y,int _pointer,com.badlogic.gdx.scenes.scene2d.Actor _toactor) throws Exception{
 //BA.debugLineNum = 342;BA.debugLine="Sub ST_1_Exit(Event As lgScn2DInputEvent, X As Float, Y As Float, Pointer As Int, ToActor As lgScn2DActor)";
 //BA.debugLineNum = 344;BA.debugLine="End Sub";
return "";
}
public static String  _st_1_keydown(com.badlogic.gdx.scenes.scene2d.InputEvent _event,int _keycode) throws Exception{
 //BA.debugLineNum = 346;BA.debugLine="Sub ST_1_KeyDown(Event As lgScn2DInputEvent, KeyCode As Int)";
 //BA.debugLineNum = 348;BA.debugLine="End Sub";
return "";
}
public static String  _st_1_keytyped(com.badlogic.gdx.scenes.scene2d.InputEvent _event,char _character) throws Exception{
 //BA.debugLineNum = 354;BA.debugLine="Sub ST_1_KeyTyped(Event As lgScn2DInputEvent, Character As Char)";
 //BA.debugLineNum = 356;BA.debugLine="End Sub";
return "";
}
public static String  _st_1_keyup(com.badlogic.gdx.scenes.scene2d.InputEvent _event,int _keycode) throws Exception{
 //BA.debugLineNum = 350;BA.debugLine="Sub ST_1_KeyUp(Event As lgScn2DInputEvent, KeyCode As Int)";
 //BA.debugLineNum = 352;BA.debugLine="End Sub";
return "";
}
public static String  _st_1_touchdown(com.badlogic.gdx.scenes.scene2d.InputEvent _event,float _x,float _y,int _pointer) throws Exception{
 //BA.debugLineNum = 358;BA.debugLine="Sub ST_1_TouchDown(Event As lgScn2DInputEvent, X As Float, Y As Float, Pointer As Int)";
 //BA.debugLineNum = 360;BA.debugLine="flTouchDown = DateTime.Now";
_fltouchdown = anywheresoftware.b4a.keywords.Common.DateTime.getNow();
 //BA.debugLineNum = 361;BA.debugLine="Event.Handle";
_event.handle();
 //BA.debugLineNum = 362;BA.debugLine="End Sub";
return "";
}
public static String  _st_1_touchdragged(com.badlogic.gdx.scenes.scene2d.InputEvent _event,float _x,float _y,int _pointer) throws Exception{
 //BA.debugLineNum = 364;BA.debugLine="Sub ST_1_TouchDragged(Event As lgScn2DInputEvent, X As Float, Y As Float, Pointer As Int)";
 //BA.debugLineNum = 366;BA.debugLine="End Sub";
return "";
}
public static String  _st_1_touchup(com.badlogic.gdx.scenes.scene2d.InputEvent _event,float _x,float _y,int _pointer) throws Exception{
 //BA.debugLineNum = 368;BA.debugLine="Sub ST_1_TouchUp(Event As lgScn2DInputEvent, X As Float, Y As Float, Pointer As Int)";
 //BA.debugLineNum = 370;BA.debugLine="If (DateTime.Now - flTouchDown) < 2000 Then";
if ((anywheresoftware.b4a.keywords.Common.DateTime.getNow()-_fltouchdown)<2000) { 
 //BA.debugLineNum = 371;BA.debugLine="foLGdx_ScrMgr.CurrentScreen = foLGdx_Screen(0)";
mostCurrent._folgdx_scrmgr.setCurrentScreen(mostCurrent._folgdx_screen[(int) (0)]);
 }else {
 //BA.debugLineNum = 373;BA.debugLine="Activity.Finish";
mostCurrent._activity.Finish();
 };
 //BA.debugLineNum = 375;BA.debugLine="Event.handle";
_event.handle();
 //BA.debugLineNum = 376;BA.debugLine="End Sub";
return "";
}
public static String  _st0_toast_show(Object _dummy) throws Exception{
 //BA.debugLineNum = 263;BA.debugLine="Sub ST0_Toast_Show(dummy As Object)";
 //BA.debugLineNum = 264;BA.debugLine="ToastMessageShow(\"Tap screen to switch.\", False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Tap screen to switch.",anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 265;BA.debugLine="End Sub";
return "";
}
public static String  _st1_toast_show(Object _dummy) throws Exception{
 //BA.debugLineNum = 378;BA.debugLine="Sub ST1_Toast_Show(dummy As Object)";
 //BA.debugLineNum = 379;BA.debugLine="ToastMessageShow(\"Hold touch for 3 seconds on blue screen to exit.\", False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Hold touch for 3 seconds on blue screen to exit.",anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 380;BA.debugLine="End Sub";
return "";
}
public static String  _update_loading(float _progress) throws Exception{
 //BA.debugLineNum = 155;BA.debugLine="Private Sub Update_Loading(Progress As Float)";
 //BA.debugLineNum = 156;BA.debugLine="pgbLoading.Progress = (Progress * 100)";
mostCurrent._pgbloading.setProgress((int) ((_progress*100)));
 //BA.debugLineNum = 157;BA.debugLine="DoEvents";
anywheresoftware.b4a.keywords.Common.DoEvents();
 //BA.debugLineNum = 158;BA.debugLine="End Sub";
return "";
}
}
